@echo off

:config
set box_ip=192.168.0.222
set tool_pfad=c:\programme\dboxzeit\
set zeitzonen_korrektur=0
set sommerzeit_beachten=0
set bericht_zeigen=1

:testeinstellungen
set pause_vor_loeschen=0
set nobox_test=0
set nobox_testdatum=07.03.2004
set nobox_testzeit=18:15:00

:tool_pfad_test
if not exist %tool_pfad%nul echo.
if not exist %tool_pfad%nul echo Fehler: Das Verzeichnis %tool_pfad% existiert nicht.
if not exist %tool_pfad%nul echo.
if not exist %tool_pfad%nul echo Bitte die Datei liesmich.txt lesen.
if not exist %tool_pfad%nul echo.
if not exist %tool_pfad%nul echo Eine beliebige Taste druecken um das Programm zu beenden.
if not exist %tool_pfad%nul pause > nul
if not exist %tool_pfad%nul exit

:nt_familie_test
echo. > %tool_pfad%log.txt
if not "%OS%"=="Windows_NT" (
   echo Fehler: >> %tool_pfad%log.txt
   echo Das Betriebssystem gehoert nicht zur NT-Familie. >> %tool_pfad%log.txt
   echo Benoetigt wird Windows XP. >> %tool_pfad%log.txt
   goto fehler
)

:cmd_erweiterungen_test
set erweiterungen=aus
set /a testext=5-2
if "%testext%"=="3" set erweiterungen=an
set testext=
if "%erweiterungen%"=="aus" set /a=
if not "%erweiterungen%"=="an" (
   echo Fehler: >> %tool_pfad%log.txt
   echo Die Erweiterungen fuer CMD sind nicht aktiv.>> %tool_pfad%log.txt
   goto fehler
)

:system_version_auf_2000_oder_XP_oder_2003_oder_Vista_oder_7_pruefen
set bs_version=unbekannt
set bs_kompatibel=nein

ver > %tool_pfad%bs_version1.tmp
type %tool_pfad%bs_version1.tmp | find.exe "Microsoft" > %tool_pfad%bs_version2.tmp
set /p bs_version= < %tool_pfad%bs_version2.tmp
set bs_version=%bs_version:~27,4%
if "%bs_version%"=="6.1." (
   set bs_version=Win7
   goto bs_auswerten
)
if "%bs_version%"=="6.0." (
   set bs_version=Vista
   goto bs_auswerten
)
if "%bs_version%"=="5.2." (
   set bs_version=2003
   goto bs_auswerten
)
set /p bs_version= < %tool_pfad%bs_version2.tmp
set bs_version=%bs_version:~18,4%
if "%bs_version%"=="XP [" (
   set bs_version=XP
   goto bs_auswerten
)
if "%bs_version%"=="2000" (
   set bs_version=2000
   goto bs_auswerten
)

:bs_auswerten
if "%bs_version%"=="Win7" set bs_kompatibel=ja
if "%bs_version%"=="Vista" set bs_kompatibel=ja
if "%bs_version%"=="2003"  set bs_kompatibel=ja
if "%bs_version%"=="XP"    set bs_kompatibel=ja
if "%bs_version%"=="2000"  set bs_kompatibel=ja
if not "%bs_kompatibel%"=="ja" (
   echo Fehler: >> log.txt
   echo Das Betriebssystem ist nicht Windows 2000, XP, 2003 oder Vista. >> log.txt
   goto fehler
)

:pfad_und_dateien_pruefen
if not exist %tool_pfad%nul (
   echo Fehler: >> %tool_pfad%log.txt
   echo Der Pfad %tool_pfad% wurde nicht gefunden. >> %tool_pfad%log.txt
   echo Bitte den Eintrag pruefen tool_pfad = %tool_pfad% >> %tool_pfad%log.txt
   echo Leerzeichen im Pfad sind nicht gestattet. >> %tool_pfad%log.txt
   echo Den abschliessenden Backslash "\" nicht vergessen. >> %tool_pfad%log.txt
   goto fehler
)
set /a datei_fehlt=0
set /a datei1_fehlt=0
set /a datei2_fehlt=0
set /a datei3_fehlt=0
set /a datei4_fehlt=0
if not exist %tool_pfad%wget.exe set /a datei1_fehlt=1
if not exist %tool_pfad%libeay32.dll set /a datei2_fehlt=1
if not exist %tool_pfad%ssleay32.dll set /a datei3_fehlt=1
if not exist %tool_pfad%enter.txt set /a datei4_fehlt=1
set /a datei_fehlt=%datei1_fehlt%+%datei2_fehlt%+%datei3_fehlt%+%datei4_fehlt%
if %datei_fehlt% gtr 0 (
   echo Fehler: >> %tool_pfad%log.txt
   echo Folgende Datei/en wurde/n nicht gefunden: >> %tool_pfad%log.txt
   if %datei1_fehlt% equ 1 echo - wget.exe >> %tool_pfad%log.txt
   if %datei2_fehlt% equ 1 echo - libeay32.dll >> %tool_pfad%log.txt
   if %datei3_fehlt% equ 1 echo - ssleay32.dll >> %tool_pfad%log.txt
   if %datei4_fehlt% equ 1 echo - enter.txt >> %tool_pfad%log.txt
   echo eventuell liegt der Fehlern bei tool_pfad = %tool_pfad% >> %tool_pfad%log.txt
   goto fehler
)

:zeitzonen_korrektur_pruefen
if %zeitzonen_korrektur% lss -23 (
   echo Fehler: >> %tool_pfad%log.txt
   echo Der Wert fuer zeitzonen_korrektur darf -23 nicht unterschreiten. >> %tool_pfad%log.txt
   goto fehler
)
if %zeitzonen_korrektur% gtr 23 (
   echo Fehler: >> %tool_pfad%log.txt
   echo Der Wert fuer zeitzonen_korrektur darf 23 nicht ueberschreiten. >> %tool_pfad%log.txt
   goto fehler
)

:kommandozeilenparameter_auswerten
if "%1"=="" set /a verschiebung=0
if not "%1"=="" set /a verschiebung=%1
if not "%1"=="%verschiebung%" (
   if not "%verschiebung%"=="0" (
      echo Fehler: >> %tool_pfad%log.txt
      echo %1 ist kein gueltiger Parameter. >> %tool_pfad%log.txt
      echo Der angegebene Parameter muss zwischen -60 und 60 liegen. >> %tool_pfad%log.txt
      goto fehler
   )
)
if %verschiebung% lss -60 (
   echo Fehler: >> %tool_pfad%log.txt
   echo Der angegebene Parameter darf -60 nicht unterschreiten. >> %tool_pfad%log.txt
   goto fehler
)
if %verschiebung% gtr 60 (
   echo Fehler: >> %tool_pfad%log.txt
   echo Der angegebene Parameter darf 60 nicht ueberschreiten. >> %tool_pfad%log.txt
   goto fehler
)

:pc_zeit_holen
date /t > %tool_pfad%get_datum.tmp
time < %tool_pfad%enter.txt > %tool_pfad%get_zeit.tmp
set /p pc_datum= < %tool_pfad%get_datum.tmp
if "%bs_version%"=="Vista" set pc_datum=%pc_datum:~0,10%
if "%bs_version%"=="2003"  set pc_datum=%pc_datum:~0,10%
if "%bs_version%"=="XP"    set pc_datum=%pc_datum:~0,10%
if "%bs_version%"=="2000"  set pc_datum=%pc_datum:~3,10%
set /p pc_zeit= < %tool_pfad%get_zeit.tmp
set pc_zeit=%pc_zeit:~15,8%
if "%pc_zeit:~0,1%"==" " set pc_zeit=0%pc_zeit:~1,7%

:dbox_zeit_holen
if not "%nobox_test%"=="0" (
   echo %nobox_testdatum% > %tool_pfad%get_datum.tmp
   echo %nobox_testzeit% > %tool_pfad%get_zeit.tmp
)
if "%nobox_test%"=="0" (
   %tool_pfad%wget.exe http://%box_ip%/control/getdate -t 1 -T 1 -o %tool_pfad%wget_log1.tmp -O %tool_pfad%get_datum.tmp
   %tool_pfad%wget.exe http://%box_ip%/control/gettime -t 1 -T 1 -o %tool_pfad%wget_log2.tmp -O %tool_pfad%get_zeit.tmp
)

:box_zeit_auswerten
set /p box_datum= < %tool_pfad%get_datum.tmp
if errorlevel 1 goto fehler
set /p box_zeit= < %tool_pfad%get_zeit.tmp
if errorlevel 1 goto fehler
if not "%nobox_test%"=="0" (
   set box_datum=%box_datum:~0,10%
   set box_zeit=%box_zeit:~0,8%
)
set /a box_jahr=%box_datum:~6,4%
set box_monat=%box_datum:~3,2%
if "%box_monat:~0,1%"=="0" set box_monat="%box_monat:~1,1%"
set /a box_monat=%box_monat%
set box_tag=%box_datum:~0,2%
if "%box_tag:~0,1%"=="0" set box_tag="%box_tag:~1,1%"
set /a box_tag=%box_tag%
set box_stunde=%box_zeit:~0,2%
if "%box_stunde:~0,1%"=="0" set box_stunde="%box_stunde:~1,1%"
set /a box_stunde=%box_stunde%
set box_minute=%box_zeit:~3,2%
if "%box_minute:~0,1%"=="0" set box_minute="%box_minute:~1,1%"
set /a box_minute=%box_minute%
set box_sekunde=%box_zeit:~6,2%
if "%box_sekunde:~0,1%"=="0" set box_sekunde="%box_sekunde:~1,1%"
set /a box_sekunde=%box_sekunde%

:verschiebung_und_zeitzonen_korrektur_einrechnen
set datum_vor=nein
set datum_zurueck=nein
set /a box_sekunde=%box_sekunde%+%verschiebung%

if %box_sekunde% gtr 59 set /a box_minute=%box_minute% +1
if %box_sekunde% lss 0 set /a box_minute=%box_minute% -1
if %box_sekunde% gtr 59 set /a box_sekunde=%box_sekunde% -60
if %box_sekunde% lss 0 set /a box_sekunde=%box_sekunde% +60

if %box_minute% gtr 59 set /a box_stunde=%box_stunde% +1
if %box_minute% lss 0 set /a box_stunde=%box_stunde% -1
if %box_minute% gtr 59 set /a box_minute=%box_minute% -60
if %box_minute% lss 0 set /a box_minute=%box_minute% +60

set /a zeitzonen_korrektur=%zeitzonen_korrektur%
set /a box_stunde=%box_stunde%+%zeitzonen_korrektur%

if %box_stunde% gtr 23 set datum_vor=ja
if %box_stunde% lss 0 set datum_zurueck=ja
if %box_stunde% gtr 23 set /a box_stunde=%box_stunde% -24
if %box_stunde% lss 0 set /a box_stunde=%box_stunde% +24
if "%datum_vor%"=="ja" goto ein_tag_vor_1
if "%datum_zurueck%"=="ja" goto ein_tag_zurueck_1
goto sommerzeit_pruefen

:ein_tag_vor_1
set /a box_tag=%box_tag% +1
if %box_tag% gtr 31 set /a box_tag=1
if %box_tag% equ 31 (
   if %box_monat% equ 4 set /a box_tag=1
   if %box_monat% equ 6 set /a box_tag=1
   if %box_monat% equ 9 set /a box_tag=1
   if %box_monat% equ 11 set /a box_tag=1
)
if %box_tag% equ 30 (
   if %box_monat% equ 3 set /a box_tag=1
)
set /a schaltjahr_test=%box_jahr% /4
set /a schaltjahr_test=%schaltjahr_test% *4
if not "%schaltjahr_test%"=="%box_jahr%" (
   if "%box_tag%.%box_monat%"=="29.2" set /a box_tag=1
)
if %box_tag% equ 1 set /a box_monat=%box_monat% +1
if %box_monat% gtr 12 set /a box_jahr=%box_jahr% +1
if %box_monat% gtr 12 set /a box_monat=1
goto sommerzeit_pruefen

:ein_tag_zurueck_1
set /a box_tag=%box_tag% -1

if %box_tag% lss 1 (
   set /a box_tag=31
   set /a box_monat=%box_monat% -1
)
if %box_monat% lss 1 (
   set /a box_monat=1
   set /a box_jahr=%box_jahr% -1
)
if %box_tag% equ 31 (
   if %box_monat% equ 2 set /a box_tag=29
   if %box_monat% equ 4 set /a box_tag=30
   if %box_monat% equ 6 set /a box_tag=30
   if %box_monat% equ 9 set /a box_tag=30
   if %box_monat% equ 11 set /a box_tag=30
)
set /a schaltjahr_test=%box_jahr% /4
set /a schaltjahr_test=%schaltjahr_test% *4
if not "%schaltjahr_test%"=="%box_jahr%" (
   if "%box_tag%.%box_monat%"=="29.2" set /a box_tag=28
)
goto sommerzeit_pruefen

:sommerzeit_pruefen
if %box_jahr% lss 2000 goto fehler
set /a jahreszahl=%box_jahr%-2000
set /a schalttage=%jahreszahl%/4-%jahreszahl%/100+%jahreszahl%/400
set /a tageanzahl=%jahreszahl%+%schalttage%
set /a korrekturwert=%tageanzahl%-(%tageanzahl%/7)*7
set /a sommer_anfang=26-%korrekturwert%
if %sommer_anfang% lss 25 set /a sommer_anfang=%sommer_anfang%+7
set /a sommer_ende=%sommer_anfang%+3
if %sommer_ende% gtr 31 set /a sommer_ende=%sommer_ende%-7

set /a sommerzeit=0
set /a box_datums_wert=%box_monat%*10000+%box_tag%*100+%box_stunde%
set /a sommer_anfang_wert=30000+%sommer_anfang%*100+1
set /a sommer_ende_wert=100000+%sommer_ende%*100+1
if %box_datums_wert% gtr %sommer_anfang_wert% set /a sommerzeit=1
if %box_datums_wert% gtr %sommer_ende_wert%   set /a sommerzeit=0
set sommerzeit_geprueft=ja

:sommerzeit_einrechnen
set datum_vor=nein
set datum_zurueck=nein
if "%sommerzeit_beachten%"=="1" set /a box_stunde=%box_stunde%+%sommerzeit%
if %box_stunde% gtr 23 set datum_vor=ja
if %box_stunde% lss 0 set datum_zurueck=ja
if %box_stunde% gtr 23 set /a box_stunde=%box_stunde% -24
if %box_stunde% lss 0 set /a box_stunde=%box_stunde% +24
if "%datum_vor%"=="ja" goto ein_tag_vor_2
if "%datum_zurueck%"=="ja" goto ein_tag_zurueck_2
goto zeit_setzen

:ein_tag_vor_2
set /a box_tag=%box_tag% +1
if %box_tag% gtr 31 set /a box_tag=1
if %box_tag% equ 31 (
   if %box_monat% equ 4 set /a box_tag=1
   if %box_monat% equ 6 set /a box_tag=1
   if %box_monat% equ 9 set /a box_tag=1
   if %box_monat% equ 11 set /a box_tag=1
)
if %box_tag% equ 30 (
   if %box_monat% equ 3 set /a box_tag=1
)
set /a schaltjahr_test=%box_jahr% /4
set /a schaltjahr_test=%schaltjahr_test% *4
if not "%schaltjahr_test%"=="%box_jahr%" (
   if "%box_tag%.%box_monat%"=="29.2" set /a box_tag=1
)
if %box_tag% equ 1 set /a box_monat=%box_monat% +1
if %box_monat% gtr 12 set /a box_jahr=%box_jahr% +1
if %box_monat% gtr 12 set /a box_monat=1
goto zeit_setzen

:ein_tag_zurueck_2
set /a box_tag=%box_tag% -1

if %box_tag% lss 1 (
   set /a box_tag=31
   set /a box_monat=%box_monat% -1
)
if %box_monat% lss 1 (
   set /a box_monat=1
   set /a box_jahr=%box_jahr% -1
)
if %box_tag% equ 31 (
   if %box_monat% equ 2 set /a box_tag=29
   if %box_monat% equ 4 set /a box_tag=30
   if %box_monat% equ 6 set /a box_tag=30
   if %box_monat% equ 9 set /a box_tag=30
   if %box_monat% equ 11 set /a box_tag=30
)
set /a schaltjahr_test=%box_jahr% /4
set /a schaltjahr_test=%schaltjahr_test% *4
if not "%schaltjahr_test%"=="%box_jahr%" (
   if "%box_tag%.%box_monat%"=="29.2" set /a box_tag=28
)
goto zeit_setzen

:zeit_setzen
if %box_sekunde% lss 10 set box_sekunde=0%box_sekunde%
if %box_minute% lss 10 set box_minute=0%box_minute%
if %box_stunde% lss 10 set box_stunde=0%box_stunde%
if %box_tag% lss 10 set box_tag=0%box_tag%
if %box_monat% lss 10 set box_monat=0%box_monat%
set neue_zeit=%box_stunde%:%box_minute%:%box_sekunde%
set neues_datum=%box_tag%.%box_monat%.%box_jahr%

time %neue_zeit%
date %neues_datum%

:bericht_schreiben
echo   Bericht: >> %tool_pfad%log.txt
echo   ---------------------------------------- >> %tool_pfad%log.txt
echo   DBox ist  : %box_datum% %box_zeit% >> %tool_pfad%log.txt
set vorzeichen=+
if %zeitzonen_korrektur% lss 0 set vorzeichen=-
if %zeitzonen_korrektur% lss 0 set /a zeitzonen_korrektur=%zeitzonen_korrektur%*-1
if %zeitzonen_korrektur% gtr 9 echo   Zeitzone  : %vorzeichen% %zeitzonen_korrektur% Stunden >> %tool_pfad%log.txt
if %zeitzonen_korrektur% lss 10 (
   if %zeitzonen_korrektur% gtr 1 echo   Zeitzone  : %vorzeichen%  %zeitzonen_korrektur% Stunden >>  %tool_pfad%log.txt
)
if %zeitzonen_korrektur% equ 1 echo   Zeitzone  : %vorzeichen%  %zeitzonen_korrektur% Stunde >>  %tool_pfad%log.txt
if "%sommerzeit_beachten%"=="1" (
   if %sommerzeit% equ 1 echo   Sommerzeit: +  1 Stunde >> %tool_pfad%log.txt
)
set vorzeichen=+
if %verschiebung% lss 0 set vorzeichen=-
if %verschiebung% lss 0 set /a verschiebung=%verschiebung%*-1
if %verschiebung% gtr 9 echo   Anpassung : %vorzeichen% %verschiebung% Sekunden >> %tool_pfad%log.txt
if %verschiebung% lss 10 (
   if %verschiebung% gtr 1 echo   Anpassung : %vorzeichen%  %verschiebung% Sekunden >>  %tool_pfad%log.txt
)
if %verschiebung% equ 1 echo   Anpassung : %vorzeichen%  %verschiebung% Sekunde >>  %tool_pfad%log.txt
echo   PC war    : %pc_datum% %pc_zeit% >> %tool_pfad%log.txt
echo   PC soll   : %neues_datum% %neue_zeit% >> %tool_pfad%log.txt
date /t > %tool_pfad%get_datum.tmp
time < %tool_pfad%enter.txt > %tool_pfad%get_zeit.tmp
set /p pc_datum= < %tool_pfad%get_datum.tmp
if "%bs_version%"=="Vista" set pc_datum=%pc_datum:~0,10%
if "%bs_version%"=="2003"  set pc_datum=%pc_datum:~0,10%
if "%bs_version%"=="XP"    set pc_datum=%pc_datum:~0,10%
if "%bs_version%"=="2000"  set pc_datum=%pc_datum:~3,10%

set /p pc_zeit= < %tool_pfad%get_zeit.tmp
set pc_zeit=%pc_zeit:~15,8%
if "%pc_zeit:~0,1%"==" " set pc_zeit=0%pc_zeit:~1,7%
echo   PC ist    : %pc_datum% %pc_zeit% >> %tool_pfad%log.txt
echo   ---------------------------------------- >> %tool_pfad%log.txt
echo   Sommerzeit in %box_jahr% ist vom %sommer_anfang%.03.-%sommer_ende%.10. >> %tool_pfad%log.txt

echo. >> %tool_pfad%log.txt
if not "%bericht_zeigen%"=="0" (
   echo.
   type %tool_pfad%log.txt
)
if "%nobox_test%"=="0" (
   echo WGet Log: >> %tool_pfad%log.txt
   echo. >> %tool_pfad%log.txt
   if exist %tool_pfad%wget_log1.tmp type %tool_pfad%wget_log1.tmp >> %tool_pfad%log.txt
   echo. >> %tool_pfad%log.txt
   if exist %tool_pfad%wget_log2.tmp type %tool_pfad%wget_log2.tmp >> %tool_pfad%log.txt
   echo.
   echo PC-Zeit: %pc_datum% %pc_zeit% neu gesetzt. Log.txt
)
if not "%nobox_test%"=="0" (
   echo   Achtung: >> %tool_pfad%log.txt
   echo   -------- >> %tool_pfad%log.txt
   echo   Die Zeit wurde nicht von der dbox ermittelt, sondern >> %tool_pfad%log.txt
   echo   die festen Testwerte aus den Testeinstellungen von >> %tool_pfad%log.txt
   echo   DBoxZeit verwendet, weil "nobox_test" nicht gleich 0 ist. >> %tool_pfad%log.txt
   echo.  >> %tool_pfad%log.txt
   echo    :testeinstellungen >> %tool_pfad%log.txt
   echo    set nobox_test=%nobox_test% >> %tool_pfad%log.txt
   echo    set nobox_testdatum=%nobox_testdatum% >> %tool_pfad%log.txt
   echo    set nobox_testzeit=%nobox_testzeit% >> %tool_pfad%log.txt
   echo.
   echo PC-Zeit auf Testwerte %pc_datum% %pc_zeit% gesetzt. Log.txt
)
if not "%bericht_zeigen%"=="0" echo.

goto loeschen

:loeschen
if not "%pause_vor_loeschen%"=="0" (
   echo.
   echo Beliebige Tast zum Fortsetzen druecken
   pause > %tool_pfad%nul
)
if exist %tool_pfad%bs_version1.tmp del %tool_pfad%bs_version1.tmp
if exist %tool_pfad%bs_version2.tmp del %tool_pfad%bs_version2.tmp
if exist %tool_pfad%wget_log1.tmp del %tool_pfad%wget_log1.tmp 
if exist %tool_pfad%wget_log2.tmp del %tool_pfad%wget_log2.tmp 
if exist %tool_pfad%get_datum.tmp del %tool_pfad%get_datum.tmp
if exist %tool_pfad%get_zeit.tmp del %tool_pfad%get_zeit.tmp
set box_ip=
set tool_pfad=
set pause_vor_loeschen=
set bericht_zeigen=
set zeitzonen_korrektur=
set sommerzeit_beachten=
set verschiebung=
set nobox_test=
set nobox_testdatum=
set nobox_testzeit=
set erweiterungen=
set bs_version=
set bs_kompatibel=
set datei_fehlt=
set datei1_fehlt=
set datei2_fehlt=
set datei3_fehlt=
set datei4_fehlt=
set pc_datum=
set pc_zeit=
set box_datum=
set box_zeit=
set box_sekunde=
set box_minute=
set box_stunde=
set box_tag=
set box_monat=
set box_jahr=
set neue_zeit=
set neues_datum=
set schaltjahr_test=
set jahreszahl=
set schalttage=
set tageanzahl=
set korrekturwert=
set sommer_anfang=
set sommer_ende=
set sommerzeit=
set sommerzeit_geprueft=
set datum_vor=
set datum_zurueck=
set box_datums_wert=
set sommer_anfang_wert=
set sommer_ende_wert=
set vorzeichen=
goto ende

:fehler
echo. >> %tool_pfad%log.txt
echo Neue Zeit wurde nicht gesetzt. >> %tool_pfad%log.txt
echo. >> %tool_pfad%log.txt
echo Wenn oben kein spezieller Fehler ausgewiesen ist, >> %tool_pfad%log.txt
echo war vielleicht die dbox nicht erreichbar. >> %tool_pfad%log.txt
echo. >> %tool_pfad%log.txt
echo WGet Log: >> %tool_pfad%log.txt
echo. >> %tool_pfad%log.txt
if exist %tool_pfad%wget_log1.tmp type %tool_pfad%wget_log1.tmp >> %tool_pfad%log.txt
echo. >> %tool_pfad%log.txt
if exist %tool_pfad%wget_log2.tmp type %tool_pfad%wget_log2.tmp >> %tool_pfad%log.txt
if not "%bericht_zeigen%"=="0" type %tool_pfad%log.txt
echo Neue Zeit wurde nicht gesetzt. Error (log.txt)
goto loeschen

:ende

:version 1.5 (c)fee 2004-2009